# BLUPF90 guided study

# LAB 3 - University of Florida, 2022 

#Daniela Lourenco | Natalia Leite 


#@dodo128
cd /home/natalia/blupf90-uf/lab3


#=========================================================================================================
#Ex 01-02

cd /home/natalia/blupf90-uf/lab3/ex1-3

#Ex01:
# Copying files to our folder.

# Check how the genotype file and map files are added in renum.par!

# Running renumf90 and saving the log file
renumf90 renum.par | tee renum.log


#Ex02:

#We'll run BLUPF90 to get solutions so we can calculate SNP effects later on

# Let's assume the genotype file is clear and turn off quality control!

#Run ssGBLUP:
mkdir ssgblup; cd ssgblup
grep -v OPTION ../renf90.par > ssgblup.par  #copying the parameter file without OPTIONS
#adding options to parameter file '../' means the files are located in the previous folder
sed -i 's:renf90.dat:../renf90.dat:g' ssgblup.par
sed -i 's:renadd02.ped:../renadd02.ped:g' ssgblup.par
echo "OPTION SNP_file ../snp3.2k" >> ssgblup.par
echo "OPTION no_quality_control" >> ssgblup.par
echo "OPTION map_file ../mrkmap.txt" >> ssgblup.par


#Now we will estimate SNP weights using the linear and non linear method
#For that, we will create two separate folders:

mkdir linear ; cd linear
# Run blupf90 
cp ../ssgblup/ssgblup.par .
#Add the option to calculate snp weights here
echo "OPTION snp_p_value" >> ssgblup.par
echo ssgblup.par | blupf90 | tee blup.log


# Run postGSf90
cp ../ssgblup/postgs.par postgs2.par

# Create a vector of weights D=I at first
# For one iteratioin only the weights are 1 ... D=I
awk 'BEGIN { for (i==1;i<45000;i++) print 1}' > W
echo "OPTION weightedG W" >> postgs2.par
echo "OPTION Manhattan_plot" >> postgs2.par
#Variance per window of 20 SNP 
echo "OPTION windows_variance 20" >> postgs2.par
echo postgs2.par | postGSf90 | tee postgs.log

#TWO Manhattan plots will be generated: variance by snp, variance by window


***** TIP *********
#The two graphs will be displayed automatically after postgsf90 
#However, they can be displayed at any time using the command:
gnuplot Sft1e2.gnuplot
gnuplot Vft1e2.gnuplot
#The same graphs can also be displayed in R (See *.R files in the folder)
*******************


#Now we will do the same process but now using nonlinear weights

mkdir non_linear ; cd non_linear
# Run blupf90 
cp ../ssgblup/ssgblup.par .
#Add the option to calculate snp weights here
echo "OPTION snp_p_value" >> ssgblup.par
echo ssgblup.par | blupf90 | tee blup.log


# Run postGSf90
cp ../ssgblup/postgs.par postgs2.par

# Create a vector of weights D=I at first
# For one iteratioin only the weights are 1 ... D=I
awk 'BEGIN { for (i==1;i<45000;i++) print 1}' > W
echo "OPTION weightedG W" >> postgs2.par
echo "OPTION Manhattan_plot" >> postgs2.par
#Variance per window of 20 SNP 
echo "OPTION windows_variance 20" >> postgs2.par
echo "OPTION which_weight nonlinearA" >> postgs2.par #option for non-linear weights
echo postgs2.par | postGSf90 | tee postgs.log


#Check the file chrsnp_pval:
1: trait
2: effect
3: -log10(p-value)
4: SNP
5: Chromosome
6: Position in bp

#An important file to look is snp_sol
head snp_sol
 
#contains solutions of SNP and weights
1: trait
2: effect
3: SNP
4: Chromosome
5: Position
6: SNP solution
7: weight

#if OPTION windows_variance is used
8: variance explained by n adjacents SNP.

#if OPTION snp_p_value is used
9: variance of the SNP solution (used to compute the p-value)


***** TIP *********
#read more about posgsf90 options and files here:
http://nce.ads.uga.edu/wiki/doku.php?id=readme.pregsf90
*******************


#=========================================================================================================
#Ex 03:

# Run one more iteration, updating the weights
cd ../linear
cp solutions solutions_1
cp snp_sol snp_sol_1
cp chrsnp chrsnp_1
cp W W_1
awk 'NR>1 {print $7}' snp_sol > W #updating our weights 
echo ssgblup.par | blupf90 | tee ssgblup2.log
echo postgs2.par | postGSf90 | tee postgs2.log

cd ../non_linear
cp solutions solutions_1
cp snp_sol snp_sol_1
cp chrsnp chrsnp_1
cp W W_1 
awk 'NR>1 {print $7}' snp_sol > W #updating our weights 
echo ssgblup.par | blupf90 | tee gblup2.log
echo postgs3.par | postGSf90 | tee postgs2.log


#Example of iteration script for WssGBLUP

#Use a bash file for running this loop in the server
awk 'BEGIN { for (i==1;i<45000;i++) print 1}' > W
for i in {1..2}
do
echo ssgblup.par | blupf90 | tee ssgblup.log_$i
cp solutions solutions_$i
echo postgs3.par | postGSf90 | tee postgs.log_$i
cp snp_sol snp_sol_$i
cp chrsnp chrsnp_$i
cp W W_$i
cp Sft1e2.R plots/Sft1e2_$i.R
cp Vft1e2.R plots/Vft1e2_$i.R
awk 'NR>1 {print $7}' snp_sol > W
done
cd ../


#=========================================================================================================
#Ex-optinal 

#Metafouders

cd /home/natalia/blupf90-uf/lab3/ex-opt

#Without MF
mkdir ssgblup; cd ssgblup
cp ../renum.par .
ln -s ../newped.txt .
ln -s ../snp_file.txt .
sed -i 's:newdata.txt:../newdata.txt:g' renum.par
cp ../renum.sh .
echo renum.par | renumf90 | tee renumf.log

echo 'ulimit -s unlimited
export OMP_STACKSIZE=1G
blupf90test <<AA > blup.log
renf90.par
AA' > ssgblup.sh
bash ssgblup.sh &

#reduced data for validation
mkdir val; cd val
#removing the phenotypes of animals from the 10th gen 
awk '{print $4}' renf90.dat | sort +0 -1 | uniq -c | sort -n

   1340 0
   6400 1
   6400 2
   6400 3
   6400 4
   6400 5
   6400 6
   6400 7
   6400 8
   6400 9
   7600 10  <-- validation animals 

awk '$4<10' ../renf90.dat > renf90_val.dat
cp ../renf90.par .
sed -i 's:renf90.dat:renf90_val.dat:g' renf90.par
sed -i 's:snp_file.txt:../snp_file.txt:g' renf90.par
sed -i 's:renadd02.ped:../renadd02.ped:g' renf90.par
cp ../ssgblup.sh .
bash ssgblup.sh &


#With MF
cd ../../
mkdir mf_ssgblup; cd mf_ssgblup
#Now we are code animals from generation 0 (founders) from line 1 as MF=-1 and founders from line 2 as MF=-2
#Animals from later genenations will keep the same
awk '{if ($4==0 && $7==1) print $1,-1,-1; else if ($4==0 && $7==2) print $1,-2,-2; else print $1,$2,$3}' ../newdata.txt > mfped.txt
ln -s ../snp_file.txt .
cp ../renum.par .
#inserting lines in renum.par for analysis with MF
sed -i '25i\UPG_TYPE' renum.par
sed -i '26i\in_pedigrees' renum.par
sed -i 's:newdata.txt:../newdata.txt:g' renum.par
sed -i 's:newped.txt:mfped.txt:g' renum.par #!!! pedigree with MF codification 
cp ../renum.sh .
bash renum.sh &

gammaf90 --snpfile snp_file.txt --pedfile renadd02.ped


#!! IMPORTANT STEP:
cp gamma.txt renadd02.ped_gamma
cp renf90.par grenf90.par
sed -i 's:add_an_upginb:add_an_meta:g' grenf90.par

echo 'ulimit -s unlimited
export OMP_STACKSIZE=1G
blupf90test <<AA > blup.log
grenf90.par
AA' > ssgblup.sh
bash ssgblup.sh &

#reduced data for validation
mkdir val; cd val
awk '$4<10' ../renf90.dat > renf90_val.dat
cp ../grenf90.par .
sed -i 's:renf90.dat:renf90_val.dat:g' grenf90.par #using the reduced data
sed -i 's:snp_file.txt:../snp_file.txt:g' grenf90.par
sed -i 's:renadd02.ped:../renadd02.ped:g' grenf90.par
cp ../ssgblup.sh .
bash ssgblup.sh &


#Validation
cd ../../
mkdir validation; cd validation
#Getting our benchmark = TBV
awk '$4==10{print $1,$6}' ../newdata.txt | sort +0 -1 > tbv.temp #Orig_ID, TBV


#NO MF

#getting the ID for the genotyped animals (code in column $6 of renaddxx.ped 
#means: 10 (if genotyped + known parents)
awk '$6>=10{print $10,$1}' ../ssgblup/renadd02.ped | sort +0 -1 > id.temp #orig_ID, renum_ID

***** TIP *********
#Consult the BLUF90 manual - page 15 for a full description on renaddxx.ped files
http://nce.ads.uga.edu/wiki/lib/exe/fetch.php?media=blupf90_all2.pdf
*******************

join -1 +1 -2 +1 id.temp tbv.temp | awk '{print $2,$1,$3}' | sort +0 -1 > id.tbv.temp #renum_id, orig_id, tbv

#Animal effect (GEBV) = effect 2 
awk '$2==2{print $3,$4}' ../ssgblup/solutions | sort +0 -1 > sol.temp
join -1 +1 -2 +1 id.tbv.temp sol.temp > tbv.sol  #solutions NO MF 

#WITH MF
awk '$6>=10{print $10,$1}' ../mf_ssgblup/renadd02.ped | sort +0 -1 > mf_id.temp
join -1 +1 -2 +1 mf_id.temp tbv.temp | awk '{print $2,$1,$3}' | sort +0 -1 > mf_id.tbv.temp
awk '$2==2{print $3,$4}' ../mf_ssgblup/solutions | sort +0 -1 > mf_sol.temp
join -1 +1 -2 +1 mf_id.tbv.temp mf_sol.temp > mf_tbv.sol  #solutions WITH MF


#Now we'll calculate the predictability and dispersion of GEBV of validation animals in R


#Start R for calculations:
R
ssgblup=read.table(file="tbv.sol")
colnames(ssgblup)<- c("id", "orig_id", "tbv", "gebv")

mf_ssgblup=read.table(file="mf_tbv.sol")
colnames(mf_ssgblup)<- c("id", "orig_id", "tbv", "gebv")

# Accuracy as COR(TBV,GEBV)
round(cor(ssgblup$tbv,ssgblup$gebv,use="pairwise.complete.obs"),2)
round(cor(mf_ssgblup$tbv,mf_ssgblup$gebv,use="pairwise.complete.obs"),2)

#Regression TBV ~ GEBV
reg=lm(ssgblup$tbv~ssgblup$gebv)
summary(reg)

#Regression TBV~GEBV
reg2=lm(mf_ssgblup$tbv~mf_ssgblup$gebv)
summary(reg2)

q()
n

Accuracy no MF: 0.62
Accuracy with MF: 0.61
b1 no MF: 1.17
b1 with MF: 1.11

#The inclusion of metafounders decreased dispersion, but did not increased the predictability!